﻿Imports System.Management

Module Module1
    Sub Main()
        Dim strUser As String = ""
        Dim strPass As String = ""
        Dim objManagementScope As ManagementScope = ConnectManagementScope("winsvr2012.local", strUser, strPass)
        'Call DefineVM(objManagementScope, "VM01", "D:\Hyper-V\VM01", 2)
        'Call DeleteVM(objManagementScope, "VM01")
        'Call SetMemory(objManagementScope, "VM01", True, 1024, 512, 2048, 5000, 20)
    End Sub

    Function ConnectManagementScope(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String) As ManagementScope
        Dim objConnectionOptions As New ConnectionOptions()
        objConnectionOptions.Impersonation = ImpersonationLevel.Impersonate 'WMI への接続に使用される偽装レベルを設定
        objConnectionOptions.EnablePrivileges = True 'WNI経由の操作のためにユーザー特権を有効にする
        objConnectionOptions.Username = strAccount
        objConnectionOptions.Password = strPassword
        Dim objManagementScope As New ManagementScope("\\" + strServer + "\root\virtualization\v2", objConnectionOptions)
        objManagementScope.Connect()
        Return (objManagementScope)
    End Function

    Function DefineVM(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strFolderPath As String, intGeneration As Integer) As Boolean
        Dim objVirtualSystemSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualSystemSettingData"), Nothing)
        Dim objVirtualSystemSettingDataInstance As ManagementObject = objVirtualSystemSettingData.CreateInstance
        objVirtualSystemSettingDataInstance("ElementName") = strVMName
        objVirtualSystemSettingDataInstance("ConfigurationDataRoot") = strFolderPath
        objVirtualSystemSettingDataInstance("VirtualSystemSubType") = "Microsoft:Hyper-V:SubType:" & intGeneration
        objVirtualSystemSettingDataInstance("VirtualNumaEnabled") = False
        Dim strSystemsettingData As String = objVirtualSystemSettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("DefineSystem")
            objParams("SystemSettings") = strSystemsettingData
            objParams("ResourceSettings") = Nothing
            objParams("ReferenceConfiguration") = Nothing
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("DefineSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function DeleteVM(ByVal objManagementScope As ManagementScope, ByVal strVMName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("DestroySystem")
            objParams("AffectedSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("DestroySystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetNumaNode(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, blnEnabled As Boolean) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemSettingData")
            objVirtualSystemsettingData = objManagementObject
            objVirtualSystemsettingData("VirtualNumaEnabled") = blnEnabled
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifySystemSettings")
            objParams("SystemSettings") = objVirtualSystemsettingData.GetText(TextFormat.CimDtd20)
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifySystemSettings", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetMemory(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, blnDynamicMemoryEnabled As Boolean, ByVal intVirtualQuantity As Integer, ByVal intReservation As Integer, ByVal intLimitMemory As Integer, ByVal intWeight As Integer, ByVal intTargetMemoryBuffer As Integer) As Boolean

        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemSettingData WHERE ElementName = '" & strVMName & "'")).Get
            objVirtualSystemSettingData = objManagementObject
        Next

        Dim objMemorySettingData As ManagementBaseObject = Nothing
        For Each objManagementObject As ManagementObject In objVirtualSystemSettingData.GetRelated("Msvm_MemorySettingData")
            objMemorySettingData = objManagementObject
            objMemorySettingData("DynamicMemoryEnabled") = blnDynamicMemoryEnabled
            objMemorySettingData("VirtualQuantity") = intVirtualQuantity
            objMemorySettingData("Reservation") = intReservation
            objMemorySettingData("Limit") = intLimitMemory
            objMemorySettingData("Weight") = intWeight
            objMemorySettingData("TargetMemoryBuffer") = intTargetMemoryBuffer
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyResourceSettings")
            objParams("ResourceSettings") = New String() {objMemorySettingData.GetText(TextFormat.CimDtd20)}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyResourceSettings", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function JobComplete(ByVal objManagementBaseObject As ManagementBaseObject, ByVal objManagementScope As ManagementScope) As Boolean
        'JobState New = 2  Starting = 3  Running = 4  Suspended = 5  ShuttingDown = 6  Completed = 7  Terminated = 8  Killed = 9  Exception = 10  Service = 11
        If objManagementBaseObject("ReturnValue") <> 0 Then
            Dim strJobPath As String = objManagementBaseObject("Job")
            Dim objJob As New ManagementObject(objManagementScope, New ManagementPath(strJobPath), Nothing)
            objJob.Get()
            Do While objJob("JobState") = 3 Or objJob("JobState") = 4
                System.Threading.Thread.Sleep(1000)
                objJob.Get()
            Loop
            If objJob("JobState") <> 7 Then
                Console.WriteLine("ErrorCode=" & objJob("ErrorCode") & " JobState=" & objJob("JobState"))
                Return False
            Else
                Return True
            End If
        Else
            Return True
        End If
    End Function
End Module
